<%-- 
    Document   : game
    Created on : Feb 17, 2021, 2:35:04 PM
    Author     : daniele.zotta
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>

<%
    
    // Controllo del passaggio del parametro via GET
    if (request.getParameter("index") == null) {
        response.sendRedirect("index.jsp");
    }
    
    // id sudoku via GET
    int id = Integer.parseInt(request.getParameter("index"));
    
%>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Sudoku <%= id %></title>
        <link rel="stylesheet" href="css/bootstrap.min.4.5.0.css"/>
        <link rel="stylesheet" href="css/style.css"/>
    </head>
    <body>
        <div class="container m-5 mx-auto">
            <h1 class="text-center">Sudoku <%= id %></h1>
            <div>
                <table id="sudoku_game" class="mx-auto mt-5">
                </table>
            </div>
            <br/>
            <form class="form-group mt-5">
                <div class="row">
                    <input type="hidden" name="sudoku_id" value="<%= id %>"/>
                    <div class="col-sm-2"></div>
                    <div class="col-sm-1">
                        <label for="input_row">Riga</label>
                    </div>
                    <div class="col-sm-2">
                        <input name="input_row" type="number" min="1" max="9" required class="form-control"/>
                    </div>
                    <div class="col-sm-1">
                        <label for="input_col">Colonna</label>
                    </div>
                    <div class="col-sm-2">
                        <input name="input_col" type="number" min="1" max="9" required class="form-control"/>
                    </div>
                    <div class="col-sm-2">
                        <button type="button" onclick="verifyInput()" class="btn btn-primary">Verifica</button>
                    </div>
                    <div class="col-sm-2"></div>
                </div>
            </form>
            <br/>
            <div class="text-center">
                <a href="index.jsp">Torna alla home</a>
            </div>
        </div>

        <script src="js/jquery.min.3.4.1.js"></script>
        <script src="js/bootstrap.min.4.5.0.js"></script>
        <script type="text/javascript">
            
            // Generazione tabella sudoku
            function generateSudoku() {
                var id = $("input[name=sudoku_id]").val();
                for (var i = 1; i < 10; i++) {
                    $("#sudoku_game").append("<tr>");
                    for (var j = 1; j < 10; j++) {
                        var attrClass = "blue";
                        if ( ((i < 4 || i > 6) && (j < 4 || j > 6)) || ((i >= 4 && i <= 6) && (j >= 4 && j <= 6))) {
                            attrClass = "rose";
                        }
                        $("#sudoku_game").append("<td>");
                        $("#sudoku_game").append("<input class=\"" + attrClass + "\" name=\"" + i + "-" + j + "\" type=\"number\" min=\"1\" max=\"9\" onchange=\"insertedValue(this)\"/>");
                        $("#sudoku_game").append("</td>");
                    }
                    $("#sudoku_game").append("</tr>");
                }
                
                $.get("GetSudokuStart?id=" + id, function(data){
                    var json = JSON.parse(data);
                    for (var x in json) {
                        var ident = "input[name=" + json[x].row + "-" + json[x].col + "]";
                        $(ident).val(json[x].value);
                        $(ident).prop("disabled", true);
                    }
                });
            }
            
            // Verifica cella inserita nel form sotto sudoku
            function verifyInput() {
                var row = $("input[name=input_row]").val();
                var col = $("input[name=input_col]").val();
                var id = $("input[name=sudoku_id]").val();
                $.get("GetCellValue?id=" + id + "&row=" + row + "&col=" + col, function(data) {
                    var json = JSON.parse(data);
                    if (json.success) {
                        if ($("input[name=" + row + "-" + col + "]").val() == json.value) {
                            alert("Il valore nella cella selezionata è giusto");
                        } else {
                            alert("Il valore nella cella selezionata è sbagliato");
                        }
                    }
                });
            }
            
            // Controllo valore inserito dall'utente
            function insertedValue(element) {
                if ($(element).val() < 1 || $(element).val() > 9) {
                    $(element).val("");
                }            
            }
            
            // Documento pronto e avvio generazione
            $(function() {
                generateSudoku();
            });
        </script>
    </body>
</html>
